'$DYNAMIC

'castx de DF6NM

'History:

'cas1g: no overflow for npix1,2 with decimation, small memory (no /AH), fc option
'cas1f: vesa bit shuffling for xp, dma timeout, tx dash
'1e2a: rx cal ph(H) optional, +- ant Q, phg/kHz, rot cw/ccw
'1e2: rx  calibration from file
'1e1b: 3.10.03: F12 ascii spectrum save, cursor VGAwin border fixed
'1e1a: mouse range + steps corrected, anti-qrn power freq limits
'1e1: decimated scales, first timer tick removed
'1d9d: full white
'1d9c: filtered decimation, nb fixed
'1d9a: towards filtered decimation
'1d9: anti-qrn inverse-power weighted averaging, H only,
'  bugs fixed: asclog, strip-edge cursor time, vgawin border, 16-bit-nb
'1d8: noise blanker
'1d7: sqr and linlog display
'cas1d6: 4.10.02: E only with colmag limit
'1d5: 19.7.02 bmp saves full screen, uncaa
'1d4: 12.5.02 ms/dot, strip cursor bugs fixed, setxy <= 65533
'1d3: 11.5.02 multi-strip
'1d1: 11.5.02: optimization of non-averaging display
'1d2: 10.5.02 DL4YHF's preliminary fix of VESA segment-boundary ovfl
'1d: 7.-10.5.02: can eat sndinput from dl4yhf

'1c9: 5.5.02 var fu, no odd byte blocks on interleave
'1c8: 3.5.02: var. samplerate, selectable SB adr. and DMA,
'   var. FFT interleave, glitch-free waitdma, half fft-win width
'1c7: 3.5.02: sb mixer setting
'1c6: 1.5.02: cursor off/on, bmp width from file, get VESA properties
'1c5: 29.4.02: VESA 800x600 and 640x480 added
'1c4: arg=, load and evaluate .bmp input
'1c3: ascii data save (Sh F12), cursor time, less memory for FFT win
'1c2 22.4.02: peak pwr/navm corrected
'1c1 21.4.02 single powd array for null
'1c 21.4.02: null in cursor direction (N key)

'1b 19.4.02 : exe without "debug code": faster
'  command line arguments, fft code in DATA
'1ax 15.4.02: compilable, dynamic arrays begin at segment without offset
'1a 14.4.02 default int instead of long: cpu 86%->78%
'castx1: morse tx functions (derived from morse1jm.bas)

'sbfft2j1  12.4.02: peak or average, cursor update
'2i8,9  11.4.02: frresponse tables, cursor printing while pointer is visible
'2i7  10.4.02 : mouse cursor rectangle
'2i5  9.4.02: mouse cursor, azimut, interpolation
'2i 7.4.02: freq and time ticks, brightness and contrast keys, new slf method
'2h9 6.4.02: memory needed for 8192-fft freed by using
'   only nm/2 warp-factors and smaller pow/re/im-arrays
'2h7 5.4.02: lin mag
'2h6 3.4.02 : correction for dual receivers
'2h4 25.3.02: bmp save (bug removed),
'   freq. response correction optimized with 90 deg Hybrid
'2h 22.3.02: freq. response correction, ems stuff removed
'2f 19.3.02: cos-RGB
'sbfft2e  18.3.02: much faster with QB45, overlapping FFTs,
'   samplerate corrected for stereo
'sbfft2c: stereo phasecolour
'  E (Marconi) -> L, H (circular polarized loop pair) -> R

'1e  19.3.00: colour phase display
'1d  19.3.00
'1c
'1b  21.9.99
'sbfft1a  18.9.99

'ccd3i.bas m.v. 18.2.99: slowscan ccd video
'  audio input sampling, clock output,ccd imagin, vesa 256 cols
'  set audio input to Line-In, "Recording" and "Line-In" 2.25 units( 0..12)
'  then start audio recorder to write the level settings to mixer.

'================================
 DEFINT A-Z
 comm$ = COMMAND$
'comm$ = "lm=11str=3in=3ti=3600 dec=100 f0=2263 fl=2271.8"
'comm$ = "lm=11str=3in=3ti=60 dec=10 f0=2150 fl=2180"
'comm$ = "lm=10str=2in=3 fl=280 col=0 white"
'comm$ = "screen=640sbmix=12sr=5541.4ph=110 lm=9in=1str=2 flq=400 white"
'comm$ = "screen=640sbmix=12sr=5541.4 lm=9in=1 uncal ph=0phg=0phq=0" 'RX calibration
'comm$ = "screen=640sbmix=12sr=5541.4 lm=9in=1 uncaa ph=90phg=0phq=0"
'comm$ = "screen=640sbmix=12sr=5541.4 in=1 fl=100 flq=600"
'comm$ = "screen=640sbmix=12sr=5541.4 in=1 fb=-138500rot=-1ph=80phg=-150fl=300"
 comm$ = UCASE$(comm$)

'user definable parameters:

'command line arguments (e.g. castx lm=13 loadbmp=TEST.bmp):
'sr lm in av ti str fb fl fu dec f0 fc decfil ahe ph phg phq
'rot col white uncal uncaa
'notone com1 com2 dash nulldir nullahe nullpwr screen xp
'sbmix sbadr sbdma loadbmp server flq fuq

'samplerate:
 sfreq& = 5513   'nominal sr
 sfreq# = 5538.287 'true sr = 23.8146336MHz/4300
 argp = INSTR(comm$, "SR=")
 IF argp > 0 THEN sfreq# = VAL(MID$(comm$, argp + 3)): sfreq& = sfreq#
 sfreq! = sfreq#

 lm = 10  'ld FFT length: 4..13 for 16..8192
 argp = INSTR(comm$, "LM="): IF argp > 0 THEN lm1 = VAL(MID$(comm$, argp + 3))
 IF lm1 >= 3 AND lm1 <= 13 THEN lm = lm1

 navm = 1  '108 * 3  'averages
 argp = INSTR(comm$, "AV="): IF argp > 0 THEN navm = VAL(MID$(comm$, argp + 3))
 IF navm <= 1 THEN navm = 1
 pepflag = 0 'peak pwr in avg interval

 dbflag = 3'1  '0 linear, 1 dB, 2 sqrt, 3 linlog
 dBmin! = -65: dBmax! = -5
 argp = INSTR(comm$, "DBMIN="): IF argp > 0 THEN dBmin! = VAL(MID$(comm$, argp + 6)): dbflag = 1
 argp = INSTR(comm$, "DBMAX="): IF argp > 0 THEN dBmax! = VAL(MID$(comm$, argp + 6)): dbflag = 1

 amaxproz! = 1!
 argp = INSTR(comm$, "AMAX="): IF argp > 0 THEN amaxproz! = VAL(MID$(comm$, argp + 5)): dbflag = 0

 fbase! = 135500 'SSB zero beat, < 0 for LSB
 argp = INSTR(comm$, "FB="): IF argp > 0 THEN fbase! = VAL(MID$(comm$, argp + 3))

 mdec = 1 'decimation
 argp = INSTR(comm$, "DEC="): IF argp > 0 THEN mdec = VAL(MID$(comm$, argp + 4))
 f0# = 0# 'nco zero beat
 argp = INSTR(comm$, "F0="): IF argp > 0 THEN f0# = VAL(MID$(comm$, argp + 3))
 fc# = 0# 'or nco center frequency
 argp = INSTR(comm$, "FC="): IF argp > 0 THEN fc# = VAL(MID$(comm$, argp + 3))
 decimateflag = 0: IF mdec > 1 OR f0# <> 0# OR fc# <> 0 THEN decimateflag = 1
 deciorder2 = 2 * 6 '2*4
 argp = INSTR(comm$, "DECFIL="): IF argp > 0 THEN deciorder2 = 2 * VAL(MID$(comm$, argp + 7))

 frlow! = 0 'lower audio freq limit
 IF lm = 11 THEN frlow! = 270  '...2303 Hz
 IF lm = 12 THEN frlow! = 1500 '...2516 Hz
 IF lm = 13 THEN frlow! = 1800 '...2308 Hz  '1895
 argp = INSTR(comm$, "FL="): IF argp > 0 THEN frlow! = VAL(MID$(comm$, argp + 3))
 frup! = sfreq! / 2'upper audio freq limit
 argp = INSTR(comm$, "FU="): IF argp > 0 THEN frup! = VAL(MID$(comm$, argp + 3))

 flq! = frlow!: fuq! = frup!  'freq limits for qrn power estimation
 argp = INSTR(comm$, "FLQ="): IF argp > 0 THEN flq! = VAL(MID$(comm$, argp + 4))
 argp = INSTR(comm$, "FUQ="): IF argp > 0 THEN fuq! = VAL(MID$(comm$, argp + 4))

 cursorflag = 1 'enables cursor display
 dycmagn = 4 ' 0...y cursor window range
 dxcmagn = 2 ' 0...x

'timer tick seconds
 tickt! = 1
  IF lm > 9 THEN tickt! = 10
  IF lm > 12 THEN tickt! = 60
  'tickt! = 30'1800
 argp = INSTR(comm$, "TI="): IF argp > 0 THEN tickt! = VAL(MID$(comm$, argp + 3))
 utchour = 0
 argp = INSTR(comm$, "UTC="): IF argp > 0 THEN utchour = VAL(MID$(comm$, argp + 4))

 ahe! = 1          'rel H/E weighting
 phoffs! = 75'110  'phase H-E (R-L)
 phgrad! = -20'- 30'-40 'linear ph. gradient (was /deg/(fs/4), now deg/kHz (/1.385))
 phquad! = 15'30   'quadratic ph. (was deg/(fs/4)^2, now deg/kHz^2 (/1.92))
 argp = INSTR(comm$, "AHE="): IF argp > 0 THEN ahe! = VAL(MID$(comm$, argp + 4))
 argp = INSTR(comm$, "PH="): IF argp > 0 THEN phoffs! = VAL(MID$(comm$, argp + 3))
 argp = INSTR(comm$, "PHG="): IF argp > 0 THEN phgrad! = VAL(MID$(comm$, argp + 4))
 argp = INSTR(comm$, "PHQ="): IF argp > 0 THEN phquad! = VAL(MID$(comm$, argp + 4))
 rot! = 1 'rotation sense  1 normal (ccw), -1 cw
 argp = INSTR(comm$, "ROT="): IF argp > 0 THEN rot! = VAL(MID$(comm$, argp + 4))

 nullflag = 0     'sharp cardioid (sin(phi/2) instead of sin(phi/2)^2)
 nulldir! = 160   'default null azimuth
 nullamplH! = 1 '1.1 'H/E weighting
 nullpow! = .5    'pwr correction
 argp = INSTR(comm$, "NULLDIR="): IF argp > 0 THEN nulldir! = VAL(MID$(comm$, argp + 8))
 argp = INSTR(comm$, "NULLAHE="): IF argp > 0 THEN nullamplH! = VAL(MID$(comm$, argp + 8))
 argp = INSTR(comm$, "NULLPWR="): IF argp > 0 THEN nullpow! = VAL(MID$(comm$, argp + 8))

 nbflag = 0: nblim = 32767: nblim0 = 10
 argp = INSTR(comm$, "NB="): IF argp > 0 THEN nbflag = 1: nblim0 = VAL(MID$(comm$, argp + 3))
 IF nbflag THEN nblim = nblim0

 rxcorflag = 1   'enable rx phase diff. and gain correction tables
  rxcalfile$ = "..\fft\rxcal486.txt"
  dBdataoffs! = -32.5
  dBdatasign! = 1
  phdataoffs! = 270 '0
  phdatasign! = 1 '-1
  RXcaldBflag = 1  '0 for SpecLab's file.fre format with linear amplitude data
  argp = INSTR(comm$, "DBDATAOFFS="): IF argp > 0 THEN dBdataoffs! = VAL(MID$(comm$, argp + 11))
  argp = INSTR(comm$, "DBDATASIGN="): IF argp > 0 THEN dBdatasign! = VAL(MID$(comm$, argp + 11))
  argp = INSTR(comm$, "PHDATAOFFS="): IF argp > 0 THEN phdataoffs! = VAL(MID$(comm$, argp + 11))
  argp = INSTR(comm$, "PHDATASIGN="): IF argp > 0 THEN phdataoffs! = VAL(MID$(comm$, argp + 11))
  argp = INSTR(comm$, "RXCALDB="): IF argp > 0 THEN RXcaldBflag = VAL(MID$(comm$, argp + 8))

 antcorflag = 1  'enable correction for loop resonance
  antFH! = 137200  'loop resonance, < 0 compensates minimum
  antQH! = antFH! / 1200  'loop loaded Q, < 0 reverses phase
  antFE! = 137200  'E-ant resonance
  antQE! = 0     'E-ant loaded Q
  argp = INSTR(comm$, "ANTFH="): IF argp > 0 THEN antFH! = VAL(MID$(comm$, argp + 6))
  argp = INSTR(comm$, "ANTQH="): IF argp > 0 THEN antQH! = VAL(MID$(comm$, argp + 6))
  argp = INSTR(comm$, "ANTFE="): IF argp > 0 THEN antFE! = VAL(MID$(comm$, argp + 6))
  argp = INSTR(comm$, "ANTQE="): IF argp > 0 THEN antQE! = VAL(MID$(comm$, argp + 6))
 argp = INSTR(comm$, "UNCAL"): IF argp > 0 THEN antcorflag = 0: rxcorflag = 0
 argp = INSTR(comm$, "UNCAA"): IF argp > 0 THEN antcorflag = 0: rxcorflag = 1

 
 txflag = 1     'enable cw tx
 txdot0 = 1 '81      'dotlen (in units of FFT duration)
 txfreq! = 2277.123 ' 1500 'pc speaker audio
  IF lm = 13 THEN txdot0 = 2: txfreq! = 2200 'qrss 3 s
 txsndflag = 1
 argp = INSTR(comm$, "NOTONE"): IF argp > 0 THEN txsndflag = 0
 cp& = 0        'com port for RTS keying
 argp = INSTR(comm$, "COM1"): IF argp > 0 THEN cp& = &H3F8
 argp = INSTR(comm$, "COM2"): IF argp > 0 THEN cp& = &H2F8
 txdash = 3
 argp = INSTR(comm$, "DASH="): IF argp > 0 THEN txdash = VAL(MID$(comm$, argp + 5))

 path$ = ""
 'path$ = "..\images\"
 filebmpsave$ = path$ + "cs"
 filelog$ = "ct"
 filespectrumlog$ = "cf"
 filebmpload$ = ""
 'filebmpload$ = "cs012311.bmp"
 'filebmpload$ = path$ + "cfh_ni~2.bmp": lm = 13: navm = 81: frlow! = 1450
 argp = INSTR(comm$, "LOADBMP="): IF argp > 0 THEN filebmpload$ = MID$(comm$, argp + 8)
 IF filebmpload$ <> "" THEN bmploadflag = 1

 widt& = 1024 '1024 or 800 or 640
 argp = INSTR(comm$, "SCREEN="): IF argp > 0 THEN widt& = VAL(MID$(comm$, argp + 7))
 xpflag = 0
 argp = INSTR(comm$, "XP="): IF argp > 0 THEN xpflag = VAL(MID$(comm$, argp + 3))

 sbmix = 0      '<>0 set mixer to line in level 0..15, 0: dont touch mixer
 sbadr = &H220  '&h220=544 or &h240=576
 sbdma = 1
 argp = INSTR(comm$, "SBMIX="): IF argp > 0 THEN sbmix = 1 + VAL(MID$(comm$, argp + 6))
 argp = INSTR(comm$, "SBADR="): IF argp > 0 THEN sbadr = VAL(MID$(comm$, argp + 6))
 argp = INSTR(comm$, "SBDMA="): IF argp > 0 THEN sbdma = VAL(MID$(comm$, argp + 6))

 server = 0   ' server=1 uses, =2 starts and uses DL4YHFs audioserver
 argp = INSTR(comm$, "SERVER="): IF argp > 0 THEN server = VAL(MID$(comm$, argp + 7))
 'audiopath$ = "d:\eigene~1\markus\basic\fft\wavrw"
 audiofile$ = "audio.dat"

 fftinterleave = 2 '1,2,3..
 catchupflag = 1
 argp = INSTR(comm$, "IN="): IF argp > 0 THEN fftin1 = VAL(MID$(comm$, argp + 3))
 IF fftin1 > 0 THEN fftinterleave = fftin1: catchupflag = 1
 IF fftin1 < 0 THEN fftinterleave = -fftin1: catchupflag = 0

 mstrip = 1
 argp = INSTR(comm$, "STR="): IF argp > 0 THEN mstrip = VAL(MID$(comm$, argp + 4))

 colfac2! = 2!  'enhanced saturation
 argp = INSTR(comm$, "COL="): IF argp > 0 THEN colfac2! = 2! * VAL(MID$(comm$, argp + 4))
 whiteflag = 0     'greyscale up to white
 argp = INSTR(comm$, "WHITE"): IF argp > 0 THEN whiteflag = 1


 '===================================
 'slf! = 0  'sat-to-lum factor 0...1 (dB cursor assumes 0!) 'removed
 pi! = 4! * ATN(1): pi2! = 2! * pi!
 sqr3! = SQR(3!)
 'astep! = SQR(SQR(SQR(10)))
 astep! = SQR(2)
 stereo = 1
 soundflag = 1 - bmploadflag
 nm = 2 ^ lm
 nbuf& = 4& * nm   '2 nm bytes  ?
 IF nbuf& < 8192 THEN nbuf& = 8192
 IF server THEN nbuf& = nbuf& \ 2  'nm words

 nm2& = 2 * nm
 nbuf1& = nbuf& - 1
 nm21 = 2 * nm - 1

 waitdmamask& = (nbuf& - 1) AND (NOT (nm2& \ fftinterleave - 1))
 winf = 1
 'IF lm >= 13 THEN winf = 2 'was coarser to save mem
 winf2 = 2 * winf

'vesa XGA screen
 depth = 8 * 3
 height = 768
 IF widt& = 800 THEN height = 600
 IF widt& = 640 THEN height = 480
 texth = 8: IF txflag THEN texth = 16
 nlin = height - texth

 yup = texth
 hstrip = nlin \ mstrip
 wids& = widt& * mstrip
 y0 = yup + hstrip - 1
 nstrip = 0

 'freq limits

 IF fc# <> 0 THEN f0# = fc# - .25# * sfreq# / mdec

  'npix1 = frlow! * nm / sfreq!
  'npix2 = frup! * nm / sfreq!

'PRINT (frlow! - f0#) * nm * mdec / sfreq!
'PRINT (frup! - f0#) * nm * mdec / sfreq!
 
  npix1! = (frlow! - f0#) * nm * mdec / sfreq!
  npix2! = (frup! - f0#) * nm * mdec / sfreq!
  IF npix1! < 0 THEN npix1! = 0
  IF npix1! > nm / 2 THEN npix1! = nm / 2
  npix1 = npix1!
  IF npix2! < 0 THEN npix2! = 0
  IF npix2! > nm / 2 THEN npix2! = nm / 2
  npix2 = npix2!
  npix = npix2 - npix1 + 1
  IF npix > hstrip THEN npix = hstrip
  IF npix < 1 THEN npix = 1
  npix2 = npix1 + npix - 1

 'freq limits for qrn power estimation
  npix1q! = (flq! - f0#) * nm * mdec / sfreq!
  IF npix1q! < npix1 THEN npix1q! = npix1
  IF npix1q! > npix2 THEN npix1q! = npix2
  npix1q = npix1q!
  npix2q! = (fuq! - f0#) * nm * mdec / sfreq!
  IF npix2q! < npix1q THEN npix2q! = npix1q
  IF npix2q! > npix2 THEN npix2q! = npix2
  npix2q = npix2q!
  nxx1q = npix1q - npix1: nxx2q = npix2q - npix1

 IF utchour < 0 THEN utchour = utchour + 24
 utcoffs! = utchour * 3600

'amplitude scaling
 afac! = 100! / amaxproz!
 dBfac! = 1! / (dBmax! - dBmin!): dBe! = 10! / LOG(10!)
 
' PRINT hstrip, npix1, npix2, npix
'END

 IF server = 2 THEN
  'SHELL audiopath$ + "sndinput2.exe /fs /dt1 /sr5513 /ch2" 'takes focus => VESA problems
  SHELL "start /m " + audiopath$ + "sndinput.exe /dt1 /sr" + LTRIM$(STR$(sfreq&)) + " /ch2"
 END IF

'arrays
 'PRINT : PRINT FRE(-2), FRE(-1), FRE(0)
 DIM asm%(63 + 192), mc%(155 + 0) 'float4a has 312 bytes
 IF soundflag THEN
  IF server THEN
   DIM a%(nbuf& - 1)
  ELSE
   DIM a%(nbuf& \ 2& - 1)
  END IF
  DIM a!(2 * nm - 1), w!(nm - 1), nbr%(nm - 1)
  DIM win!(nm \ winf \ 2 - 1)
  DIM pwsum!(npix - 1), resum!(npix - 1), imsum!(npix - 1)
  DIM pwq!(npix - 1), req!(npix - 1), imq!(npix - 1)
  DIM frre!(npix - 1), frim!(npix - 1), fram1!(npix - 1)
  DIM fticks%(npix - 1)
 END IF
 DIM dbminf!(wids& - 1), dbmaxf!(wids& - 1), timest!(wids& - 1)
 charmax = 255' 154 ' ASC("")
 DIM charmask%(charmax, 7)
 'DIM dbtab!(127)
 'PRINT FRE(-2), FRE(-1), FRE(0): CLEAR : END
  
   IF decimateflag THEN
    decbuflen = nm2&: decbuflen1 = decbuflen - 1
    f0dec# = (.25# / mdec + f0# / sfreq#)
    decfftinterleave = fftinterleave
    fftinterleave = 1
    decf2! = 1 / mdec / 2: decf1! = 1! - decf2!

    DIM adec!(decbuflen1)
    DIM ard!(deciorder2 + 1), aid!(deciorder2 + 1)
    decptr = 0: decptrstart = 0
    decptrend = (2 * (nm \ decfftinterleave)) AND decbuflen1
    ph1dec# = 0: deccnt = 0: qphase = 0
   END IF

 rbw! = sfreq! / nm / mdec
 frcrnd! = 1
 IF rbw! < 10 THEN frcrnd! = 10
 IF rbw! < 10 THEN frcrnd! = 100
 IF soundflag THEN
  tickf! = 500: GOSUB prepfticks
  tickf! = 100: GOSUB prepfticks
  IF rbw! < 1 THEN tickf! = 10: GOSUB prepfticks
  IF rbw! < .1 THEN tickf! = 1: GOSUB prepfticks
  IF rbw! < .01 THEN tickf! = .1: GOSUB prepfticks
  oldti& = -1
  FOR x = 0 TO wids& - 1: timest!(x) = -1: NEXT x

  txdot = 1
  'txdash = 3  'parameter dash=
  txpause = txdash
  txtimer = 0
  GOSUB getmorse
  IF txsndflag THEN GOSUB prepsound
  IF cp& THEN GOSUB prepcom
  GOSUB rtslo
 END IF


 SCREEN 12  'necessary for mouse and font,
 WIDTH , 60 'and VESA must start out of full screen
 
 GOSUB getfont

 IF soundflag THEN
  GOSUB getmc
  GOSUB calcw
  GOSUB calcbitrev
  GOSUB calcwindow
  'GOSUB calcdbtab  ' "fastdb" is slower than math coprocessor
  'GOSUB calcfreqcorr
  GOSUB calibrate ': END
  GOSUB calcnull
 END IF

 vwin = -1 'causes initialization of vga window
 GOSUB setvesa

 GOSUB mousereset

 GOSUB printcompass
 IF widt& >= 800 THEN p$ = "Colour Azimuth Spectrogram by DF6NM": xp0 = 280
 IF widt& = 800 THEN xp0 = 280 - 224 - 8
 IF widt& = 640 THEN p$ = "": xp0 = 272

 fr1& = sfreq! * npix1 / nm / mdec + fbase! + f0#
 fr2& = sfreq! * npix2 / nm / mdec + fbase! + f0#
 p$ = p$ + STR$(fr1&) + ".." + STR$(fr2&) + "Hz"

 rbw! = sfreq! / nm / mdec
 IF rbw! >= .1 THEN
  rbw$ = STR$(INT(.5 + 100! * rbw!) / 100) + "Hz/p"
 ELSE
  rbw$ = STR$(INT(.5 + 1000! * rbw!)) + "mHz/p"
 END IF
 IF widt& > 640 THEN p$ = p$ + rbw$
 yp0 = 0: GOSUB printfont
 IF widt& = 1024 THEN xp0 = 0: p$ = "keys +- *_/ d <> s a n N c f q": GOSUB printfont

 i$ = "": pdfl% = 1: GOSUB keypressed

 'GOSUB mouseon  'does not show any pointer on VESA :-(
 
  npixd = widt&
  nlind = npix

IF soundflag THEN
 IF server THEN
  i$ = ""
  'audio data eater for DL4YHF's SndInput
  rxlen& = 0: rxleft& = 0
  nm2 = nm2&: nbuf1 = nbuf& - 1
  xstart = 0: ninw2 = (xstart + nm2) AND nbuf1&
  closetime! = TIMER: opentime! = closetime!
  WHILE i$ <> CHR$(27)
   IF rxleft& <= 0 THEN
    ON ERROR GOTO rxerr
    OPEN audiofile$ FOR INPUT AS 1  'error handler skips to nofile
     CLOSE 1
     OPEN audiofile$ FOR BINARY AS 1
     rxlen& = LOF(1)
     rxleft& = rxlen&
     nblock = 2048'bytes
    
     lopentime! = opentime!
     opentime! = TIMER
     waittime! = opentime! - closetime!
     IF waittime! < 0! THEN waittime! = waittime! + 24! * 3600
     totaltime! = opentime! - lopentime!
     IF totaltime! < 0! THEN totaltime! = totaltime! + 24! * 3600
     cpuidle! = cpuidle! + waittime!
     cputotal! = cputotal! + totaltime!

nofile:
    ON ERROR GOTO 0
   END IF

   IF rxleft& > 0 THEN
    IF rxleft& < nblock THEN nblock = rxleft&
    a$ = INPUT$(nblock, 1)
    rxleft& = rxleft& - nblock
   
    IF (rxleft& <= 0) AND rxlen& THEN
     CLOSE 1
     KILL audiofile$
     rxlen& = 0
     closetime! = TIMER
    END IF
   
    FOR ninb = 1 TO nblock - 3 STEP 4
     a%(ninw) = CVI(MID$(a$, ninb, 2))
     a%(ninw + 1) = CVI(MID$(a$, ninb + 2, 2))
     ninw = (ninw + 2) AND nbuf1
     IF ninw = ninw2 THEN
      GOSUB process
      xstart = (xstart + (nm2 \ (2 * fftinterleave)) * 2) AND nbuf1
      ninw2 = (xstart + nm2) AND nbuf1
      IF txflag THEN GOSUB chktxtimer  ' jitters with audfilelen !
     END IF
    NEXT ninb

   END IF
   IF cursorflag THEN GOSUB cursor
   i$ = INKEY$
   IF i$ <> "" THEN GOSUB keypressed
  WEND
  IF (rxleft& <= 0) AND rxlen& THEN
   CLOSE 1: KILL audiofile$: rxlen& = 0
  END IF

 ELSE

  GOSUB setdma
  GOSUB sbinit

'main loop (polling dma ptr):
  i$ = ""
  WHILE i$ <> CHR$(27)
   GOSUB waitdmabuf
   GOSUB process
   IF txflag THEN GOSUB chktxtimer
   IF cursorflag THEN GOSUB cursor
   i$ = INKEY$
   IF i$ <> "" THEN GOSUB keypressed
   xstart& = xstart& + (nm2& \ (2 * fftinterleave)) * 2
   IF xstart& > nbuf& THEN xstart& = xstart& - nbuf&
  WEND
ende:
  IF server = 0 THEN
   dat = &HD0: GOSUB sbout 'stop dsp
dmaoff:
   GOSUB cleardma
  END IF
 END IF

 GOSUB rtslo

ELSE
  stopflag = 1: txflag = 0
  GOSUB bmpload
  FOR yd = 0 TO wids& - 1
   IF dbflag = 1 THEN
    dbminf!(yd) = dBmin!: dbmaxf!(yd) = dBmax!
   ELSE
    dbminf!(yd) = 1024 + dbflag
    dbmaxf!(yd) = 2 * dBe! * LOG(amaxproz! / 100!)
   END IF
   timest!(yd) = utcoffs! + nm / 2! / sfreq! * navm * yd
  NEXT yd
  WHILE i$ <> CHR$(27)
   IF i$ <> "" THEN GOSUB keypressed
   IF cursorflag THEN GOSUB cursor
   IF i$ = CHR$(27) THEN GOTO ende2
   i$ = INKEY$
  WEND
ende2:
END IF
 SCREEN 0 'back to QBasic window
 IF cputotal! > 0 THEN
  cpu! = INT(1000& * (1 - cpuidle! / cputotal!)) / 10
  PRINT "cpuload"; cpu!; "%  "
 END IF
 CLEAR

END

'=====================

rxerr:
  IF ERR = 53 THEN RESUME nofile 'err file not found
  SCREEN 0: PRINT "error"; ERR
 END

waitdmabuf:
 'dma length counts down, dma adress goes up
 timeout! = 8! * nm2& / sfreq!: time1! = TIMER

 IF catchupflag THEN
 'waits if dma is between xstart and xstart+nm2
  length2& = nbuf& - (xstart& + nm2&)
  OUT flipflop, 0: length1& = INP(cntport) + INP(cntport) * &H100&
  length& = length1&
  WHILE ((length& - length2&) AND (nbuf& - 1)) < nm2&
   OUT flipflop, 0: length& = INP(cntport) + INP(cntport) * &H100&
   IF cursorflag THEN GOSUB mouseptr
   time2! = TIMER: IF time2! < time1! THEN time2! = time2! + 24! * 3600!
   IF (time2! - time1!) > timeout! THEN SCREEN 0: PRINT "audio dma timeout"; timeout!; "s": END
  WEND
  cpu1& = (length1& - length2&) AND (nbuf& - 1)
  IF cpu1& < nm2& THEN cpuidle! = cpuidle! + cpu1&
  cputotal! = cputotal! + (nm2& \ fftinterleave)
 ELSE
  OUT flipflop, 0: length1& = INP(cntport) + INP(cntport) * &H100&
  length& = length1&
 'waits until msbs of bufferptr have changed
 '(ie until dma has passed any block border)
  WHILE ((length& XOR length1&) AND waitdmamask&) = 0
   OUT flipflop, 0: length& = INP(cntport) + INP(cntport) * &H100&
   IF cursorflag AND lm > 11 THEN GOSUB mouseptr
   time2! = TIMER: IF time2! < time1! THEN time2! = time2! + 24! * 3600!
   IF (time2! - time1!) > timeout! THEN SCREEN 0: PRINT "audio dma timeout"; timeout!; "s": END
  WEND
  xstart& = nbuf& - (length1& AND waitdmamask&) - nm2&
  cpuidle! = cpuidle! + (length1& AND NOT waitdmamask&)
  cputotal! = cputotal! + (nm2& \ fftinterleave)
 END IF
 RETURN

'================================
process:
  IF stopflag THEN RETURN

  'LRLR... => ReImReIm... Twin FFT length nm
  
  IF decimateflag THEN
  
   DEF SEG = VARSEG(a%(0))
   ph1dec# = ph1dec# - INT(ph1dec#)
   FOR n = 0 TO nm2& - 1 STEP 2
    ph1dec# = ph1dec# + f0dec#
    phidec! = ph1dec# * pi2!: cosdec! = COS(phidec!): sindec! = SIN(phidec!)
    'cosdec! = 1!: sindec! = 0!
    FOR lr = 0 TO 1
     IF server THEN
      a1 = a%((xstart + n + lr) AND nbuf1)
     ELSE
      a1 = PEEK((n + xstart& + lr) AND nbuf1&) - 128
     END IF
     'a1 = (RND * 255 - 128)
     'a1 = 127 * SIN((n + xstart&) * .95 * omegadec! / 2!)
     IF ABS(a1) > nblim THEN a1 = 0
     ard!(lr) = a1 * cosdec!: aid!(lr) = a1 * sindec!
     'ardx! = a1 * cosdec!: aidx! = a1 * sindec!
     FOR ndecio = 2 + lr TO deciorder2 + lr STEP 2
      ard!(ndecio) = ard!(ndecio) * decf1! + ard!(ndecio - 2) * decf2!
      aid!(ndecio) = aid!(ndecio) * decf1! + aid!(ndecio - 2) * decf2!
     NEXT ndecio
    NEXT lr
    deccnt = deccnt + 1
    IF deccnt >= mdec THEN
     deccnt = 0
     qphase = (qphase + 1) AND 3: qsign! = (qphase AND 2) - 1
     FOR lr = 0 TO 1
      IF qphase AND 1 THEN
       adec!(decptr + lr) = 2! * qsign! * aid!(deciorder2 + lr)
      ELSE
       adec!(decptr + lr) = 2! * qsign! * ard!(deciorder2 + lr)
      END IF
     NEXT lr
     decptr = (decptr + 2) AND decbuflen1
     IF decptr = decptrend THEN
      decptrstart = decptrend
      decptrend = (decptrend + 2 * (nm \ decfftinterleave)) AND decbuflen1
      dofftflag = 1
     END IF
    END IF
   NEXT n
   DEF SEG
   
   IF dofftflag THEN
    FOR n = 0 TO nm - 1
     a!(n) = win!(n \ winf2) * adec!((n + decptrstart) AND decbuflen1)
     'a!(n) = win!(n \ winf2) * (127.5 * COS(n))
    NEXT n
    nm21 = 2 * nm - 1
    FOR n = nm TO 2 * nm - 1
     a!(n) = win!((nm21 - n) \ winf2) * adec!((n + decptrstart) AND decbuflen1)
     'a!(n) = win!((nm21 - n) \ winf2) * (127.5 * COS(n))
    NEXT n
   END IF
 
  ELSE  'not decimate
   
   IF server THEN
    nbuf1 = nbuf& - 1: winf2 = 2 * winf
    FOR n = 0 TO nm - 1
     a1 = a%((xstart + n) AND nbuf1)
     IF ABS(a1) > nblim THEN a1 = 0
     a!(n) = win!(n \ winf2) * a1
     'a!(n) = win!(n \ winf2) * (32767.5 * COS(n))
    NEXT n
    nm21 = 2 * nm - 1
    FOR n = nm TO 2 * nm - 1
     a1 = a%((xstart + n) AND nbuf1)
     IF ABS(a1) > nblim THEN a1 = 0
     a!(n) = win!((nm21 - n) \ winf2) * a1
     'a!(n) = win!((nm21 - n) \ winf2) * (32767.5 * COS(n))
    NEXT n
   ELSE
    DEF SEG = VARSEG(a%(0))
    FOR n = 0 TO nm - 1
     a1 = (PEEK((n + xstart&) AND nbuf1&) - 128)
     IF ABS(a1) > nblim THEN a1 = 0
     a!(n) = win!(n \ winf2) * a1
     'a!(n) = win!(n \ winf2) * (127.5 * COS(n))
    NEXT n
    FOR n = nm TO 2 * nm - 1
     a1 = (PEEK((n + xstart&) AND nbuf1&) - 128)
     IF ABS(a1) > nblim THEN a1 = 0
     a!(n) = win!((nm21 - n) \ winf2) * a1
     'a!(n) = win!((nm21 - n) \ winf2) * (127.5 * COS(n))
    NEXT n
    DEF SEG
   END IF 'server
 
  END IF 'decimate

 IF dofftflag OR (decimateflag = 0) THEN

  GOSUB fftmc
 
  FOR n = npix1 TO npix2
   nxx = n - npix1
   n2 = n + n
   nmn2 = ((nm - n) AND (nm - 1)) * 2
  
   re1! = (a!(n2) + a!(nmn2)) * fram1!(nxx)
   im1! = (a!(n2 + 1) - a!(nmn2 + 1)) * fram1!(nxx)
   re2! = a!(n2 + 1) + a!(nmn2 + 1)
   im2! = -a!(n2) + a!(nmn2)
   
   re! = re2! * frre!(nxx) - im2! * frim!(nxx)
   im2! = im2! * frre!(nxx) + re2! * frim!(nxx)
   re2! = re!
   
   IF Eflag = 1 THEN
    pw! = 2! * (re1! * re1! + im1! * im1!)
   ELSE
    IF Eflag = 2 THEN
     pw! = 2! * (re2! * re2! + im2! * im2!)
    ELSE
     pw! = re1! * re1! + im1! * im1! + re2! * re2! + im2! * im2!
    END IF
   END IF
  
   IF nullflag THEN
    re2n! = re2! * cosnull! - im2! * sinnull!
    im2n! = re2! * sinnull! + im2! * cosnull!
    pwn! = nullpow! * ((re1! + re2n!) * (re1! + re2n!) + (im1! + im2n!) * (im1! + im2n!))
    IF pw! > 0 THEN pwx! = pwn! / pw!
    pw! = pwn!
    re! = (re1! * re2! + im1! * im2!) * pwx!
    im! = (im1! * re2! - re1! * im2!) * pwx!
   ELSE
    re! = (re1! * re2! + im1! * im2!)
    im! = (im1! * re2! - re1! * im2!)
   END IF
  
   IF navm = 1 THEN  'no averaging
    GOSUB drawpix
   ELSE
    IF pepflag = 0 THEN  'power averaging
     pwsum!(nxx) = pwsum!(nxx) + pw!
     resum!(nxx) = resum!(nxx) + re!
     imsum!(nxx) = imsum!(nxx) + im!
     IF n = npix2 THEN wsum! = wsum! + 1!
    ELSE
     IF pepflag = 1 THEN  'peak averaging
      IF pw! > pwsum!(nxx) THEN
       pwsum!(nxx) = pw!
       resum!(nxx) = re!
       imsum!(nxx) = im!
       wsum! = 1!
      END IF
     ELSE  'qrn inverse total pwr weighted averaging
      pwq!(nxx) = pw!
      req!(nxx) = re!
      imq!(nxx) = im!
      IF nxx >= nxx1q AND nxx <= nxx2q THEN pwqsum! = pwqsum! + pw!
      IF n = npix2 THEN
       qweight! = 1 / pwqsum!
       IF pepflag = 3 THEN qweight! = qweight! * qweight!
       FOR nxx = 0 TO npix2 - npix1
        pwsum!(nxx) = pwsum!(nxx) + pwq!(nxx) * qweight!
        resum!(nxx) = resum!(nxx) + req!(nxx) * qweight!
        imsum!(nxx) = imsum!(nxx) + imq!(nxx) * qweight!
        pwq!(nxx) = 0!: req! = 0!: imq! = 0!
       NEXT nxx
       wsum! = wsum! + qweight!
       pwqsum! = 1E-30
      END IF
     END IF
    END IF
   END IF
  NEXT n
 
  IF navm > 1 AND nav >= navm THEN
   FOR n = npix1 TO npix2
    nxx = n - npix1
    pw! = pwsum!(nxx): pwsum!(nxx) = 1E-30
    re! = resum!(nxx): resum!(nxx) = 0!
    im! = imsum!(nxx): imsum!(nxx) = 0!
    pw! = pw! / wsum!: re! = re! / wsum!: im! = im! / wsum!
    GOSUB drawpix
   NEXT n
   wsum! = 1E-30
  END IF
 
  IF navm = 1 OR nav >= navm THEN
' timer ticks
   ti& = INT(TIMER / tickt!)
   IF ti& <> oldti& THEN
    IF oldti& >= 0 THEN
     cr = 255: cg = 255: cb = 255
     y = y0: GOSUB setpoint
     y = y0 - npix + 1: GOSUB setpoint
    END IF
    oldti& = ti&
   END IF

'note dBmin, dBmax, timestamp for cursor
   IF dbflag = 1 THEN
    dbminf!(yd) = dBmin!: dbmaxf!(yd) = dBmax!
   ELSE
    dbminf!(yd) = 1024 + dbflag
    dbmaxf!(yd) = 2! * dBe! * LOG(amaxproz! / 100!)
   END IF
   timest!(yd) = TIMER
  
   yd = yd + 1
   xd = xd + 1
   IF xd >= widt& THEN       'new strip
    xd = 0: nstrip = nstrip + 1: y0 = y0 + hstrip
    IF nstrip = mstrip THEN  'back to top
     nstrip = 0: y0 = yup + hstrip - 1: yd = 0
    END IF
   END IF
   nav = 0
  END IF
  nav = nav + 1

  dofftflag = 0
 END IF
 RETURN

'==============
drawpix:
    x = xd: y = y0 - nxx
    s! = pw!
    SELECT CASE dbflag
     CASE 0
      lum! = SQR(s!) * afac!
     CASE 1
      lum! = (dBe! * LOG(s!) - dBmin!) * dBfac!
      IF lum! < 0! THEN lum! = 0!
     CASE 2
      lum! = SQR(SQR(s!) * afac!)
     CASE 3
      lum! = SQR(s!) * afac!
      IF lum! > .75 THEN lum! = .75 + dBe! * LOG(s! * 1.77778 * afac! * afac!) / 255!
    END SELECT

'colour: 2*cor/pwr
    colre! = colfac2! * re! / pw!
    colim! = colfac2! * im! / pw! * rot!
    colmag! = SQR(colre! * colre! + colim! * colim!)
    IF colmag! > 1! THEN colre! = colre! / colmag!: colim! = colim! / colmag!: colmag! = 1!
   
    IF whiteflag THEN lummax! = 2! / (1! + colmag!) ELSE lummax! = 1!
    IF lum! > lummax! THEN lum! = lummax!
    lum2! = 127.5 * lum!
   
    IF xd < fticks%(nxx) OR (widt& - xd) <= fticks%(nxx) THEN
     cr = 255: cg = 255: cb = 255  'white freqruler
    ELSE
'lum, col -> RGB
     cr! = 2! * colre!
     IF cr! > colmag! THEN cr! = colmag!
     IF cr! < -colmag! THEN cr! = -colmag!
     cr = lum2! * (1! + cr!)

     cg! = -colre! + colim! * sqr3!
     IF cg! > colmag! THEN cg! = colmag!
     IF cg! < -colmag! THEN cg! = -colmag!
     cg = lum2! * (1! + cg!)
    
     cb! = -colre! - colim! * sqr3!
     IF cb! > colmag! THEN cb! = colmag!
     IF cb! < -colmag! THEN cb! = -colmag!
     cb = lum2! * (1! + cb!)
    END IF '...fticks
    
   
    GOSUB setpoint
    'DEF SEG = vwinseg&
    'vadd& = y * widtb& + x * depthb: vwin1 = vadd& \ vwinsize&
    'IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
    'vax& = vadd& AND vwinsize1&
    'IF (vax& <= 65533) THEN
    ' POKE vax& + 0, cb: POKE vax& + 1, cg: POKE vax& + 2, cr
    'ELSE
    ' GOSUB setpixacrossvgawinborder
    'END IF
    'DEF SEG
  RETURN

'==============
setpixacrossvgawinborder:
    POKE vax&, cb
    vadd& = vadd& + 1&: vwin1 = vadd& \ vwinsize&
    IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
    vax& = vadd& AND vwinsize1&
    POKE vax&, cg
    vadd& = vadd& + 1&: vwin1 = vadd& \ vwinsize&
    IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
    vax& = vadd& AND vwinsize1&
    POKE vax&, cr
   RETURN
'========================
keypressed:
 IF txinput = 0 THEN
  IF i$ = "q" THEN i$ = CHR$(27): RETURN
  IF i$ = CHR$(0) + CHR$(&H86) THEN GOTO ascspectrumsave 'F12
  IF i$ = CHR$(0) + CHR$(&H88) THEN GOTO asclogsave 'Shift F12
   '&h85 = F11, 87 = Shift F11, 89 = Ctrl F11, 8B = Alt F11
   '&h86 = F12, 88 = Shift F12, 8A = Ctrl F12, 8C = Alt F12
  IF i$ = "f" THEN GOTO filesave
  IF i$ = "s" THEN stopflag = 1 - stopflag: RETURN
  IF i$ = "c" THEN
   cursorflag = 1 - cursorflag
   IF cursorflag THEN GOTO plotcursor ELSE GOTO clearcursor
  END IF
  IF i$ = "d" THEN
   dbflag = 1 + dbflag: IF dbflag > 3 THEN dbflag = 0
   pdfl% = 1
  END IF
  IF i$ = "a" THEN pafl% = 1: pepflag = pepflag + 1: IF pepflag > 3 THEN pepflag = 0
  IF i$ = "n" THEN nullflag = 1 - nullflag: pdfl% = 1
  IF i$ = "e" THEN Eflag = Eflag + 1: pdfl% = 1: IF Eflag > 2 THEN Eflag = 0
  IF i$ = "N" AND cursorflag THEN nulldir! = az: GOSUB calcnull: pdfl% = 1
  
  IF i$ = "b" THEN
   nbflag = 1 - nbflag: pdfl% = 1
   'IF server THEN nblim = 32767 ELSE nblim = 128
   IF nbflag THEN nblim = nblim0 ELSE nblim = 32767
  END IF

  IF i$ = ">" AND navm > 1 THEN navm = navm - 1: pafl% = 1
  IF i$ = "<" THEN navm = navm + 1: pafl% = 1
  IF i$ = "*" OR i$ = "/" OR i$ = "+" OR i$ = "-" OR i$ = "_" THEN
   SELECT CASE dbflag
   CASE 1
    IF i$ = "*" THEN dBmax! = dBmax! + 5!
    IF i$ = "/" OR i$ = "_" THEN dBmax! = dBmax! - 5!
    IF i$ = "-" THEN dBmin! = dBmin! - 5!: dBmax! = dBmax! - 5!
    IF i$ = "+" THEN dBmin! = dBmin! + 5!: dBmax! = dBmax! + 5!
    dBfac! = 1! / (dBmax! - dBmin!)
   CASE ELSE
    IF i$ = "*" OR i$ = "+" THEN amaxproz! = amaxproz! * astep!
    IF i$ = "/" OR i$ = "_" OR i$ = "-" THEN amaxproz! = amaxproz! / astep!
    afac! = 100! / amaxproz!
   END SELECT
   pdfl% = 1
  END IF
  IF i$ = CHR$(13) AND txflag THEN  'switch keyboard to enter tx text
   txp% = 0
   'IF cursorflag THEN txfreq! = frc! - fbase!: GOSUB prepsound
   txinput = 1: ptfl% = 1
  END IF

 ELSE 'txinput = 1
  IF i$ = CHR$(27) THEN  'abort transmitting text buffer
   tx$ = "": p1% = 9: txtime = 0
   p$ = SPACE$(widt& \ 8): yp0 = 8: xp0 = 0: GOSUB printfont: yp0 = 0: txpp% = 0
   i$ = ""   ' don't end prog
   'i$ = CHR$(13) ' but give keys back
   END IF

  IF i$ = CHR$(13) THEN 'return keyboard from text entry
   txinput = 0: pafl% = 1: pdfl% = 1
  ELSE
   p$ = " "
   IF INSTR(m$, " " + LCASE$(i$)) > 0 THEN tx$ = tx$ + i$: p$ = i$ + " "
   IF i$ = CHR$(8) AND LEN(tx$) > 0 THEN
    tx$ = LEFT$(tx$, LEN(tx$) - 1)
    txpp% = txpp% - 1: IF txpp% < 0 THEN txpp% = txpp% + widt& \ 8 - 1
   END IF
   xp0 = 8 * txpp%: yp0 = 8: GOSUB printfont: yp0 = 0
   txpp% = txpp% + LEN(p$) - 1: IF txpp% >= widt& \ 8 - 1 THEN txpp% = 0
 
   IF i$ = "<" AND txdot0 > 1 THEN txdot0 = txdot0 - 1: ptfl% = 1
   IF i$ = ">" THEN txdot0 = txdot0 + 1: ptfl% = 1
   IF cursorflag AND (i$ = "|" OR (mousebuttons AND 1) <> 0) THEN
    txfreq! = frc! - fbase!: IF txsndflag THEN GOSUB prepsound
    ptfl% = 1
   END IF

  END IF
 END IF

 IF pafl% OR pdfl% THEN
  IF dbflag = 1 THEN
   pd$ = STR$(dBmin!) + ".." + STR$(dBmax!) + "dB"
  ELSE
   apm! = INT(.5 + amaxproz! * 100!) / 100!
   'pd$ = "0.." + STR$(apm!) + "%"
   pd$ = STR$(apm!) + "%"
   IF dbflag = 2 THEN pd$ = pd$ + "s"
   IF dbflag = 3 THEN pd$ = pd$ + "+"
  END IF
  IF Eflag = 1 THEN pd$ = pd$ + "E"
  IF Eflag = 2 THEN pd$ = pd$ + "H"
  IF nbflag THEN pd$ = pd$ + "B"
  IF nullflag THEN pd$ = pd$ + STR$(nulldir!) + "N"
  ts! = nm / sfreq! / fftinterleave * navm
  IF decimateflag THEN ts! = nm / sfreq! / decfftinterleave * navm * mdec

  IF ts! >= .099 THEN
   ts! = INT(.5 + 100! * ts!) / 100!: pa$ = STR$(ts!) + "s/p" + STR$(navm)
  ELSE
   ts! = INT(.5 + 1000! * ts!): pa$ = STR$(ts!) + "ms/p" + STR$(navm)
  END IF
  IF pepflag = 0 THEN pa$ = pa$ + "av"
  IF pepflag = 1 THEN pa$ = pa$ + "pk"
  IF pepflag = 2 THEN pa$ = pa$ + "wa"
  IF pepflag = 3 THEN pa$ = pa$ + "qa"
  p$ = LEFT$(pa$ + SPACE$(14), 14) + LEFT$(pd$ + SPACE$(16), 16)
  xp0 = widt& - 1024 + 784: GOSUB printfont: pfl% = 0
  pafl% = 0: pdfl% = 0
 END IF

 IF ptfl% THEN
 
  txd0! = txdot0 / sfreq! * nm / fftinterleave
  IF txd0! > .99 THEN
   txd0! = INT(.5 + 10! * txd0!) / 10!
   p$ = "  TX:" + STR$(txfreqp! + fbase!) + "Hz" + STR$(txd0!) + "s/dot"
  ELSE
   txd0! = INT(.5 + 1000! * txd0!)
   p$ = "  TX:" + STR$(txfreqp! + fbase!) + "Hz" + STR$(txd0!) + "ms/dot"
  END IF
  p$ = LEFT$(p$ + SPACE$(30), 30)
  xp0 = widt& - 1024 + 784: GOSUB printfont: ptfl% = 0
 END IF

 RETURN

chktxtimer:
  IF txtime <= 0 THEN
   txtime = 0
   IF txon THEN
    txon = 0: txtime = txdot * txdot0
   ELSE
    p1% = p1% + 1
    m1$ = MID$(m$, pz% + p1%, 1)
    IF p1% <= 8 THEN
     IF m1$ = "." THEN
      txon = 1: txtime = txdot * txdot0
      ELSE
      IF m1$ = "-" THEN
       txon = 1: txtime = txdash * txdot0
      ELSE
       p1% = p1% + 8
       txon = 0: txtime = (txpause - txdot) * txdot0
      END IF
     END IF
    ELSE 'p1%>8
     p1% = 9
     IF LEN(tx$) > 0 THEN
      z$ = LCASE$(LEFT$(tx$, 1))
      tx$ = RIGHT$(tx$, LEN(tx$) - 1)
      pz% = INSTR(m$, " " + z$) + 1
      IF pz% > 1 THEN
       p1% = 0
      END IF
     END IF
    END IF
   END IF
   IF txon THEN
    IF txsndflag THEN OUT &H61, INP(&H61) OR 2  'tone on with coherent carrier
    GOSUB rtshi
   ELSE
    IF txsndflag THEN OUT &H61, INP(&H61) AND 253 ' output off, divider continues
    GOSUB rtslo
   END IF
  END IF 'txtime<=0
  txtime = txtime - 1
 RETURN
'===========================
cursor:
  cursornow = 1
  GOSUB mouseptr
  cursornow = 0
 RETURN

mouseptr:
  GOSUB mousestatus
'mouse still lives in screen 12 (640x480) - not any longer
  IF mousex > widt& - 1 - dxcmagn THEN mousex = widt& - 1 - dxcmagn
  'IF mousex < 0 THEN mousex = 0
  IF mousey > height - 1 - dycmagn THEN mousey = height - 1 - dycmagn
  IF mousey < texth THEN mousey = texth
 
  cupdate = cursornow AND xd >= mousex AND xd <= mousex + dxcmagn + 2
  cupdate = cupdate AND mousey + dycmagn >= y0 - hstrip AND mousey <= y0
  cupdate = cupdate OR mousey <> mouseyoldc OR mousex <> mousexoldc
  IF cupdate THEN
  GOSUB clearcursor
   IF cursornow OR stopflag THEN
    printcflag = 1
    GOSUB getcursordata
'find maximum lum in cursor window (assuming slf!=0)
'print cursor time, f and dB
    IF tsc! >= 0 THEN
     tsc! = tsc! - utcoffs!: IF tsc! < 0 THEN tsc! = tsc! + 24! * 3600!
     tsch = INT(tsc! / 3600)
     tscm = INT(tsc! / 60 - tsch * 60)
     tscs = INT(tsc! - (tsch * 60 + tscm) * 60!)
     thms$ = RIGHT$(STR$(tsch), 2) + ":" + RIGHT$("0" + LTRIM$(STR$(tscm)), 2) + ":" + RIGHT$("0" + LTRIM$(STR$(tscs)), 2)
    ELSE
     thms$ = "   "
    END IF
    pg$ = " "
    IF dbminf!(ydc) = 1027! AND lumcmax > 192 THEN pg$ = "~"
  '  IF lumcmax >= 254 THEN pg$ = " >"
    IF cmaxmax >= 254 THEN pg$ = " >"
    IF lumcmax = 0 THEN pg$ = " <"
    p$ = thms$ + STR$(frc!) + "Hz" + pg$ + LTRIM$(STR$(dbc!)) + "dB"
    IF az >= 0 THEN
     azc = az / 45: azc$ = "" + MID$("N NEE SES SWW NWN ", 2 * azc + 1, 2)
     p$ = p$ + STR$(az) + azc$
    END IF
    p$ = LEFT$(p$ + SPACE$(35), 35)
    mousexoldc = mousex: mouseyoldc = mousey
 
   END IF 'cursorupdate

   GOSUB plotcursor

   IF printcflag THEN xp0 = 0: GOSUB printfont
   mousexold = mousex: mouseyold = mousey
 
  END IF
 RETURN
'----------------------
clearcursor:  'VGA win border fixed
'reset cursor corners to old values
   y = mouseyold + dycmagn: x = mousexold: GOSUB setxy: GOSUB getp
   IF cbo + cgo + cro = 764 THEN cb = cbo0: cg = cgo0: cr = cro0: GOSUB setp
   x = mousexold + dxcmagn: GOSUB setxy: GOSUB getp
   IF cbo + cgo + cro = 764 THEN cb = cbo1: cg = cgo1: cr = cro1: GOSUB setp
   y = mouseyold: x = mousexold: GOSUB setxy: GOSUB getp
   IF cbo + cgo + cro = 764 THEN cb = cbo2: cg = cgo2: cr = cro2: GOSUB setp
   x = mousexold + dxcmagn: GOSUB setxy: GOSUB getp
   IF cbo + cgo + cro = 764 THEN cb = cbo3: cg = cgo3: cr = cro3: GOSUB setp
 RETURN

plotcursor:
'plot cursor corners to VESA
   cr = 255: cg = 255: cb = 254
   y = mousey + dycmagn: x = mousex
   GOSUB getnsetpoint: cbo0 = cbo: cgo0 = cgo: cro0 = cro
   x = mousex + dxcmagn
   GOSUB getnsetpoint: cbo1 = cbo: cgo1 = cgo: cro1 = cro
   y = mousey: x = mousex
   GOSUB getnsetpoint: cbo2 = cbo: cgo2 = cgo: cro2 = cro
   x = mousex + dxcmagn
   GOSUB getnsetpoint: cbo3 = cbo: cgo3 = cgo: cro3 = cro
 RETURN

getcursordata:
'find maximum lum in cursor window
     lumcmax = -1
     FOR dxc = 0 TO dxcmagn
      FOR dyc = dycmagn TO 0 STEP -1
       GOSUB getlumc
       IF lumc > lumcmax THEN dycmax = dyc: dxcmax = dxc: lumcmax = lumc: cmaxmax = cmax
      NEXT dyc
     NEXT dxc

'interpolation in dB:
    kdB! = 5.9

    dxc = dxcmax: dyc = dycmax + 1: GOSUB getlumc
    lum1 = lumc
    dyc = dycmax - 1: GOSUB getlumc
    IF lum1 > lumc THEN lumc = lum1: dyc = dycmax + 1
    GOSUB calcfdb     'brighter one of neighbours
    f2! = frc!: dB2! = dbc!
   
    dyc = dycmax: lumc = lumcmax
    GOSUB calcfdb      'cursormax
    f1! = frc!: dB1! = dbc!
  
    frc! = (f1! + f2!) / 2! + (f2! - f1!) * (dB2! - dB1!) / (2! * kdB!)
    dbc! = (dB1! + dB2!) / 2! + kdB! / 4! + (dB2! - dB1!) * (dB2! - dB1!) / (4! * kdB!)
    IF (dB2! - dB1!) > 1.5 * kdB! THEN frc! = f2!: dbc! = dB2!
    IF (dB1! - dB2!) > 1.5 * kdB! THEN frc! = f1!: dbc! = dB1!
    frc! = INT(.5 + frcrnd! * frc!) / frcrnd!
    dbc! = INT(.5 + 10! * dbc!) / 10!

'azimuth calculation:
    y = mousey + dycmax: x = mousex + dxcmax: GOSUB setxy: GOSUB getp
calcazimuth:
    cmin = cro: cminn = 0
    IF cbo < cmin THEN cmin = cbo: cminn = 1
    IF cgo < cmin THEN cmin = cgo: cminn = 2
    cmax = cro: cmaxn = 0
    IF cbo > cmax THEN cmax = cbo: cmaxn = 1
    IF cgo > cmax THEN cmax = cgo: cmaxn = 2
    IF cmax > cmin THEN
     cmmn = 3 * cmaxn + cminn
     IF cmmn = 1 THEN cmid = cgo: GOSUB phicmid: az! = 330! - phi!  '0 1
     IF cmmn = 2 THEN cmid = cbo: GOSUB phicmid: az! = 30! + phi!   '0 2
     IF cmmn = 5 THEN cmid = cro: GOSUB phicmid: az! = 90! - phi!   '1 2
     IF cmmn = 3 THEN cmid = cgo: GOSUB phicmid: az! = 150! + phi!  '1 0
     IF cmmn = 6 THEN cmid = cbo: GOSUB phicmid: az! = 210! - phi!  '2 0
     IF cmmn = 7 THEN cmid = cro: GOSUB phicmid: az! = 270! + phi!  '2 1
     az = 90! - az!: IF az < 0 THEN az = az + 360
    ELSE
     az = -1
    END IF
 RETURN

phicmid:
  sinphi! = ((cmid - (cmax + cmin) / 2!) / (cmax - cmin))
  phi! = 180! / pi! * ATN(sinphi! / SQR(1 - sinphi! * sinphi!))
 RETURN

calcfdb:
  y = mousey + dyc: x = mousex + dxc
  IF x >= widt& THEN x = widt& - 1 '(should not happen)
  stripc = (y - yup) \ hstrip: IF stripc >= mstrip THEN stripc = mstrip - 1
  ydc = stripc * widt& + x
  tsc! = timest!(ydc)
  y0c = yup + (stripc + 1) * hstrip - 1
calcfdb2:
  frc! = sfreq! * (y0c - y + npix1) / nm / mdec + f0# + fbase!
  SELECT CASE dbminf!(ydc)
   CASE 1024!  'linear display
    dbc! = -199
    IF lumc > 0 THEN dbc! = dbmaxf!(ydc) + 2! * dBe! * LOG(lumc / 255!)
   CASE 1026!  'sqrt display
    dbc! = -199
    IF lumc > 0 THEN dbc! = dbmaxf!(ydc) + 4! * dBe! * LOG(lumc / 255!)
   CASE 1027!  'linlog display 3/4
    dbc! = -199
    IF lumc > 0 THEN
     IF lumc <= 192 THEN
      dbc! = dbmaxf!(ydc) + 2! * dBe! * LOG(lumc / 255!)
     ELSE
      dbc! = dbmaxf!(ydc) - 2.498775 + (lumc - 192)
     END IF
    END IF
   CASE ELSE 'dB display
    dbc! = (lumc / 255!) * (dbmaxf!(ydc) - dbminf!(ydc)) + dbminf!(ydc)
  END SELECT
  
 RETURN

getlumc:
  y = mousey + dyc: x = mousex + dxc: GOSUB setxy: GOSUB getp
  cmin = cro
  IF cbo < cmin THEN cmin = cbo
  IF cgo < cmin THEN cmin = cgo
  cmax = cro
  IF cbo > cmax THEN cmax = cbo
  IF cgo > cmax THEN cmax = cgo
  lumc = cmin + cmax
 RETURN
'-----------------------
asclogsave:
 IF cursorflag = 0 THEN RETURN
  GOSUB clearcursor
  t$ = TIME$: dt$ = LEFT$(t$, 2) + MID$(t$, 4, 2) + RIGHT$(t$, 2)
  OPEN path$ + filelog$ + dt$ + ".txt" FOR OUTPUT AS 2
  PRINT #2, " time/s freq/Hz level/dB DOA/deg"
  mousexb = mousex: mouseyb = mousey
  dxcmagnb = dxcmagn: dxcmagn = 0
  mousex = yd
  stripc = (mousey - yup) \ hstrip: IF stripc >= mstrip THEN stripc = mstrip - 1
  mousey = mousey + (nstrip - stripc) * hstrip
  FOR xals = 0 TO wids& - 1
   GOSUB getcursordata
   IF tsc! >= 0 THEN
    tsc! = tsc! - utcoffs!: IF tsc! < 0 THEN tsc! = tsc! + 24! * 3600!
    PRINT #2, tsc!;
    PRINT #2, frc!; dbc!; az
   END IF
   mousex = mousex + 1
   IF mousex >= widt& THEN
    mousex = mousex - widt&: mousey = mousey + hstrip
    IF mousey > mstrip * hstrip THEN mousey = mousey - mstrip * hstrip
   END IF
  NEXT xals
  mousex = mousexb: mousey = mouseyb: dxcmagn = dxcmagnb
  CLOSE 2
  GOSUB plotcursor
  p$ = "log saved for" + STR$(frc!) + "Hz  ": xp0 = 0: GOSUB printfont
 RETURN

ascspectrumsave:
 IF cursorflag = 0 THEN RETURN
  GOSUB clearcursor
  t$ = TIME$: dt$ = LEFT$(t$, 2) + MID$(t$, 4, 2) + RIGHT$(t$, 2)
  y = mousey + (dycmagn \ 2): x = mousex + (dxcmagn \ 2)
  IF x >= widt& THEN x = widt& - 1 '(should not happen)
  stripc = (y - yup) \ hstrip: IF stripc >= mstrip THEN stripc = mstrip - 1
  ydc = stripc * widt& + x
  tsc! = timest!(ydc)
  y0c = yup + (stripc + 1) * hstrip - 1
  IF tsc! >= 0 THEN
   OPEN path$ + filespectrumlog$ + dt$ + ".txt" FOR OUTPUT AS 2
   tsc! = tsc! - utcoffs!: IF tsc! < 0 THEN tsc! = tsc! + 24! * 3600!
   PRINT #2, " time "; tsc!; "s"
   PRINT #2, " freq/Hz level/dB DOA/deg"
   FOR y = y0c TO y0c - (npix - 1) STEP -1
    GOSUB setxy: GOSUB getp
    GOSUB calcazimuth  'also gets cmin and cmax for lumc
    lumc = cmin + cmax
    GOSUB calcfdb2
    dbc! = INT(.5 + 10! * dbc!) / 10!
    PRINT #2, frc!; dbc!; az
   NEXT y
   CLOSE 2
   p$ = "spectrum saved for" + STR$(tsc!) + "s  ": xp0 = 0: GOSUB printfont
  END IF
  GOSUB plotcursor
 RETURN

'===================
setpoint:
  GOSUB setxy: GOTO setp

getnsetpoint:
  GOSUB setxy: GOSUB getp: GOTO setp

setxy:
   SELECT CASE xpflag

   CASE 0 'linear video ram (dos, win98)
    vadd& = y * widtb& + x * depthb
  
   CASE 1 'bit shuffling for win xp (qrl pc)
    vl& = y * widt& + x
    vadd& = (vl& AND &H1F&) + (vl& AND &H3E0&) * 16& 'bit 13..9   4..0
    vadd& = vadd& + (vl& AND &H400&) * 16&    'bit   14   'xp
    vadd& = vadd& + (vl& AND &H7800&) \ 64&  'bit   8..5   'xp
    vadd& = vadd& + (vl& AND &HF8000)        'bit 19..14   'notebook
    vadd& = vadd& * depthb
  
   CASE 2 'bit shuffling for win xp (notebook amilo m 7400)
    vl& = y * widt& + x
    vadd& = (vl& AND &H1F&) + (vl& AND &H3E0&) * 16&  'bit 13..9   4..0
    vadd& = vadd& + (vl& AND &H3C00&) \ 32&  'bit   8..5   'xp
    vadd& = vadd& + (vl& AND &HFC000)        'bit 19..14   'notebook
    vadd& = vadd& * depthb
   END SELECT

   vwin1 = vadd& \ vwinsize&
   DEF SEG = vwinseg&
   IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
   vax& = vadd& AND vwinsize1&
   'IF (vax& > 65533) THEN vax& = vax& - 3&  'preliminary fix only !!
 RETURN

setxyorig:
   DEF SEG = vwinseg&
   vadd& = y * widtb& + x * depthb: vwin1 = vadd& \ vwinsize&
   IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
   vax& = vadd& AND vwinsize1&
   'IF (vax& > 65533) THEN vax& = vax& - 3&  'preliminary fix only !!
 RETURN

getp:
  IF (vax& <= 65533) THEN
   cbo = PEEK(vax&): cgo = PEEK(vax& + 1): cro = PEEK(vax& + 2)
  ELSE
   GOSUB getpixacrossvgawinborder: GOSUB setxy
  END IF
 RETURN

setp:
  IF (vax& <= 65533) THEN
   POKE vax&, cb: POKE vax& + 1, cg: POKE vax& + 2, cr
  ELSE
   GOSUB setpixacrossvgawinborder: GOSUB setxy
  END IF
 RETURN

getpixacrossvgawinborder:
   cbo = PEEK(vax&)
   vadd& = vadd& + 1&: vwin1 = vadd& \ vwinsize&
   IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
    vax& = vadd& AND vwinsize1&
   cgo = PEEK(vax&)
   vadd& = vadd& + 1&: vwin1 = vadd& \ vwinsize&
   IF vwin <> vwin1 THEN vwin = vwin1: GOSUB setvgawin: DEF SEG = vwinseg&
   vax& = vadd& AND vwinsize1&
   cro = PEEK(vax&)
  RETURN

'================
getfont:
  FOR nc = 32 TO charmax
   LOCATE 1, 1: PRINT CHR$(nc);
   FOR y = 0 TO 7
    chm = 0
    FOR x = 0 TO 7
     chm = 2 * chm - (POINT(x, y) <> 0)
    NEXT x
    charmask%(nc, y) = chm
   NEXT y
  NEXT nc
 RETURN

printfont:
 crp = 255: cbp = 255: cgp = 255
printfontc:
 FOR nc = 1 TO LEN(p$)
  chr = ASC(MID$(p$, nc, 1)): IF chr > charmax THEN chr = 127
  FOR yi = 0 TO 7
   chm = charmask%(chr, yi)
   FOR xi = 0 TO 7
    y = yp0 + yi: x = xp0 + 8 * (nc - 1) + xi
    chbit = chm \ 128: chm = 2 * (chm AND 127)
    cr = crp * chbit: cg = cgp * chbit: cb = cbp * chbit
    GOSUB setpoint
   NEXT xi
  NEXT yi
 NEXT nc
 RETURN

printcompass:
 xpc0 = widt& - 24
 p$ = "E": xp0 = xpc0 + 10: yp0 = 30: crp = 255: cgp = 0: cgp = 0: GOSUB printfontc
 p$ = "N": xp0 = xpc0: yp0 = 20: crp = 128: cbp = 255: cgp = 0: GOSUB printfontc
 p$ = "W": xp0 = xpc0 - 10: yp0 = 30: crp = 0: cbp = 255: cgp = 255: GOSUB printfontc
 p$ = "S": xp0 = xpc0: yp0 = 40: crp = 128: cbp = 0: cgp = 255: GOSUB printfontc
 p$ = "+": xp0 = xpc0: yp0 = 30: crp = 128: cbp = 128: cgp = 128: GOSUB printfontc
RETURN
'====================
'DMA stuff
setdma:
 aadr& = 16& * (VARSEG(a%(0)) AND &HFFFF&)  'different from VARSEG(a%) !!
 IF (aadr& XOR (aadr& + nbuf&)) AND &HF0000 THEN
 ' SCREEN 0
 ' PRINT "dma buffer (a%) wraparound "; HEX$(aadr&); " to "; HEX$(aadr& + nbuf& - 1)
 ' END
  p$ = "dma wraparound " + HEX$(aadr&) + " to " + HEX$(aadr& + nbuf& - 1) + "  "
  xp0 = 0: GOSUB printfont
 END IF

 dmachan = sbdma '1
 'dma channel 1 (Win sndrec32 uses ch1 for rec and ch5 for 16bit play)

 IF dmachan < 4 THEN
   adrport = 2 * dmachan
   cntport = adrport + 1
   status = 8
   request = 9
   mask1 = &HA
   mode = &HB
   flipflop = &HC
   resetport = &HD
  ELSE
   adrport = &HC0 + 4 * (dmachan - 4)
   cntport = adrport + 2
   status = &HC0 + 2 * 8
   request = &HC0 + 2 * 9
   mask1 = &HC0 + 2 * &HA
   mode = &HC0 + 2 * &HB
   flipflop = &HC0 + 2 * &HC
   resetport = &HC0 + 2 * &HD
  END IF
  pageregs$ = "7321fb9a": page = VAL("&h8" + MID$(pageregs$, dmachan + 1, 1))

FOR n = 1 TO 0
 OUT flipflop, 0: adress = INP(adrport) + INP(adrport) * &H100&
 OUT flipflop, 0: length = INP(cntport) + INP(cntport) * &H100&
 IF dmachan > 3 THEN adress = 2 * adress
 adress = adress + INP(page) * &H10000
 PRINT dmachan, HEX$(adress), HEX$(length)
NEXT n

'(play from array)
'sample to array
 aadrm& = aadr&
 ahl& = aadrm& AND &HFFFF
 IF dmachan > 3 THEN ahl& = ahl& \ 2
 al = ahl& AND 255: ah = ahl& \ 256
 ap = (aadrm& \ &H10000) AND 255: IF dmachan > 3 THEN ap = ap AND &HFE
 cl = (nbuf& - 1) AND 255: ch = ((nbuf& - 1) \ 256)

 OUT mask1, (dmachan AND 3) + 4 'off
 'OUT mode, (dmachan AND 3) + &H18 '/demand /inc autoinit ramtoperi
 OUT mode, (dmachan AND 3) + &H14 '/demand /inc autoinit peritoram
 OUT page, ap
 OUT flipflop, 0: OUT adrport, al: OUT adrport, ah
 OUT flipflop, 0: OUT cntport, cl: OUT cntport, ch
 OUT mask1, (dmachan AND 3) 'on
 'PRINT "dma set"
RETURN

cleardma:
 OUT mask1, (dmachan AND 3) + 4 'dma off
RETURN
'___________________
'soundblaster

sbinit:
 'sbadr = &H220
 bits = 8 '16

 sbmixadr = sbadr + 4   '!!
 sbmixdat = sbadr + 5
 sbreset = sbadr + 6
 sbread = sbadr + 10
 sbwri = sbadr + 12
 sbrstatus = sbadr + 14

 IF sbmix THEN
  OUT sbmixadr, 0: OUT sbmixdat, 0  'mixer resrt
  OUT sbmixadr, &HC: OUT sbmixdat, 6  'line in with lowpass
  OUT sbmixadr, &H2E: OUT sbmixdat, (sbmix - 1) * &H11 'line level 00..ff
 END IF

 OUT sbreset, 1
 FOR del = 1 TO 100: NEXT del
 OUT sbreset, 0
 WHILE (INP(sbrstatus) AND 128) = 0: WEND: rd = INP(sbread)
 IF HEX$(rd) <> "AA" THEN GOTO dmaoff
 dat = &HE1: GOSUB sbout 'ask sb version
 WHILE (INP(sbrstatus) AND 128) = 0: WEND: rd1 = INP(sbread)
 WHILE (INP(sbrstatus) AND 128) = 0: WEND: rd2 = INP(sbread)
 'PRINT "soundblaster ver"; rd1; "."; rd2; "found at "; HEX$(sbadr)

 'dat = &HD1: GOSUB sbout 'speaker on
 dat = &HD1: GOSUB sbout 'speaker off

 IF stereo THEN
  dat = &HA8: GOSUB sbout 'stereo recording
  dat = &H40: GOSUB sbout 'set sfreq
  dat = (256 - 1000000 \ 2 \ sfreq&): GOSUB sbout
 ELSE
  dat = &HA0: GOSUB sbout 'mono recording
  dat = &H40: GOSUB sbout 'set sfreq
  dat = (256 - 1000000 \ sfreq&): GOSUB sbout
 END IF
 dat = &H48: GOSUB sbout 'set blocklen
 dat = (nbuf& - 1) AND 255: GOSUB sbout 'length
 dat = (nbuf& - 1) \ 256: GOSUB sbout   'length
 'dat = &H1C: GOSUB sbout '8bit play autoinit
 dat = &H2C: GOSUB sbout '8bit record autoinit
RETURN

sbout:
  WHILE (INP(sbwri) AND 128): WEND: OUT sbwri, dat
RETURN

'====================
filesave:

 ' depth = 8 * 3
 ' height = 768
 ' widt& = 1042

 'ex wav2bmp4a.bas
  IF depthb = 2 THEN RETURN 'no save for hicolor
  depthbf = depthb: IF depthb = 4 THEN depthbf = 3
  colmaplen = 0: IF depthb = 1 THEN colmaplen = 256 * 4
 
'filename __hhmmss
  t$ = TIME$: dt$ = LEFT$(t$, 2) + MID$(t$, 4, 2) + RIGHT$(t$, 2)
  OPEN filebmpsave$ + dt$ + ".bmp" FOR OUTPUT AS 2

'write bmpheader
  'width must be multiple of 4!
  totallen& = 54& + colmaplen + 1& * widt& * height * depthbf
  H$ = "BM" + MKL$(totallen&) + MKL$(0) + MKL$(54 + colmaplen) + MKL$(40) '18
  H$ = H$ + MKL$(widt&) + MKL$(height) + MKI$(1) + MKI$(depthbf * 8)       '12
  H$ = H$ + STRING$(24, 0)
  FOR C = 0 TO colmaplen \ 4 - 1
   H$ = H$ + CHR$(C) + CHR$(C) + CHR$(C) + CHR$(0)
  NEXT C
  PRINT #2, H$;
  'bug removed: ; was missing, colours mixed up, red shifted 1 pix left

  FOR y = height - 1 TO 0 STEP -1
   FOR x = 0 TO widt& - 1
    x3 = 3 * x
    GOSUB setxy
    'IF x = yd THEN POKE vax&, 255
    GOSUB getp
    PRINT #2, CHR$(cbo) + CHR$(cgo) + CHR$(cro);
   NEXT x
   IF INKEY$ = "q" THEN yf = 0
  NEXT y

  CLOSE 2
  filenr = filenr + 1
 RETURN
'--------------------
bmpload:
  OPEN filebmpload$ FOR BINARY AS 1
  bmplen& = LOF(1)
  IF bmplen& = 0 THEN CLOSE 1: KILL path$ + filebmpload$: RETURN
  hdr$ = INPUT$(54, 1)

  widtf& = CVL(MID$(hdr$, 18 + 1, 4))
  heightf& = CVL(MID$(hdr$, 22 + 1, 4))

  IF widtf& < widt& THEN widtread& = widtf& ELSE widtread& = widt&
  IF heightf& < nlind THEN nlinr = heightf& ELSE nlinr = nlind

  FOR y = height - 1 TO height - nlinr STEP -1
   in$ = INPUT$(3 * widtf&, 1)
   FOR x = 0 TO widtread& - 1
    x3 = 3 * x
    cb = ASC(MID$(in$, x3 + 1, 1))
    cg = ASC(MID$(in$, x3 + 2, 1))
    cr = ASC(MID$(in$, x3 + 3, 1))
    GOSUB setpoint
   NEXT x
  NEXT y
  DEF SEG
 RETURN

'================================
'vesa and interrupt stuff:

setvesa:
'  IF depth = 24 THEN depth = 32
   depthb = depth \ 8
   vwpix& = 65536 \ depthb 'vga win size in pix
  IF widt& = 800 THEN
   height = 600
   IF depth = 8 THEN mode = &H103
   IF depth = 16 THEN mode = &H114
   IF depth >= 24 THEN mode = &H115
  END IF
  IF widt& = 1024 THEN
   height = 768
   IF depth = 8 THEN mode = &H105
   IF depth = 16 THEN mode = &H117
   IF depth >= 24 THEN mode = &H118
  END IF
  IF widt& = 640 THEN
   height = 480
   IF depth = 8 THEN mode = &H101
   IF depth = 16 THEN mode = &H111
   IF depth >= 24 THEN mode = &H112
  END IF
 
  GOSUB readasmcode
 
 IF 0 THEN
  depthb = 4  'Notebook: 32 bit TrueColor
  widtb& = depthb * widt&
  vwinsize& = 64& * 1024
  vwinsize1& = vwinsize& - 1
  vgranularity& = 64& * 1024
  vbothwin = 0
  IF widt& = 640 THEN '486er
   depthb = 3
   widtb& = &H800
   vgranularity& = 4 * 1024
  END IF
 END IF
 
  regal = 1  'fn 1: ask mode properties, buffer 29 byte from es:di = &h40
  regcl = mode AND 255
  regch = mode \ 256
  GOSUB callvesa
  IF regah <> 0 OR regal <> &H4F THEN
   PRINT "VESA mode "; HEX$(mode); widt&; "x"; height; "not available": END
  END IF
  IF (PEEK(&H43) AND 7) > 0 THEN vbothwin = 1 'window 1 exists
  IF (PEEK(&H42) AND 7) = 7 THEN vbothwin = 0 'window 0 for write and read
  vgranularity& = (PEEK(&H44) + PEEK(&H45) * 256&) * 1024&
  vwinsize& = (PEEK(&H46) + PEEK(&H47) * 256&) * 1024&
  vwinsizeg& = vwinsize& \ vgranularity&
  vwinsize1& = vwinsize& - 1
  IF (vwinsize& AND vwinsize1&) <> 0 THEN
   PRINT "sorry, cannot cope with VESA window size"; vwinsize& / 1024&; "kB": END
  END IF
  vwinseg& = PEEK(&H48) + PEEK(&H49) * 256&
  widtb& = PEEK(&H50) + PEEK(&H51) * 256&  'bytes per line
  depthb = PEEK(&H59) \ 8  'bytes per pixel
 
 IF 0 THEN
  PRINT "vwinseg& "; HEX$(vwinseg&)
  PRINT "vwinsize"; vwinsize& / 1024&; "kB"
  PRINT "vgranularity&"; vgranularity&
  PRINT "widtb& "; widtb&
  PRINT "depthb"; depthb
  PRINT "vbothwin"; vbothwin
  END
 END IF

  regal = 2  'fn 2: set vesa mode
  regbl = mode AND 255
  regbh = mode \ 256
  GOSUB callvesa
 
  DEF SEG


 'FOR yy = 0 TO height - 1
 ' x = yy: y = yy: cr = 255: cg = yy \ 3: cb = 255 - yy \ 3
 ' GOSUB setpoint
 'NEXT yy

 RETURN

setvgawin:
  IF vbothwin THEN
   regbl = 1   'fenster nr. 1
   GOSUB setvgawin1
  END IF
  regbl = 0   'fenster nr. 0
setvgawin1:
  regdx& = vwin * vwinsizeg&
  regal = 5   'fn 5 (verschieben des zugriffsfensters)
'regah = 0 '?
  regbh = 0
  regdl = regdx& AND 255&
  regdh = regdx& \ 256&
callvesa:
  interrupt = &H10
  regah = &H4F
callinterrupt:
  DEF SEG = VARSEG(asm%(0))
  POKE 7, regal: POKE 8, regah
  POKE &HA, regbl: POKE &HB, regbh
  POKE &HD, regcl: POKE &HE, regch
  POKE &H10, regdl: POKE &H11, regdh
  POKE &H13, interrupt
  CALL absolute(0)
  regal = PEEK(&H30): regah = PEEK(&H31)
  regbl = PEEK(&H32): regbh = PEEK(&H33)
  regcl = PEEK(&H34): regch = PEEK(&H35)
  regdl = PEEK(&H36): regdh = PEEK(&H37)
 RETURN

fillvesa: '(not used)
  FOR np = 0 TO (height * widt& \ 65536) * (depth \ 8) - 1
   vwin = np: GOSUB setvgawin
   DEF SEG = vwinseg& '&HA000&
   FOR n& = 0 TO 65535
    POKE n&, n& AND 255
   NEXT n&
  NEXT np
 '768k *2byte in ca. 4 sec =330kB/s !
 RETURN


mousereset:
 interrupt = 51
 regah = 0: regal = 0 'reset
 GOSUB callinterrupt
 regah = 0: regal = 7   'set x range
 regch = 0: regcl = 0
 regdh = (4 * widt&) \ 256: regdl = (4 * widt&) AND 255  'later divided by 4!
 GOSUB callinterrupt
 regah = 0: regal = 8   'set y range
 regch = 0: regcl = 0
 'regdh = height \ 256: regdl = height AND 255
 regdh = (4 * height) \ 256: regdl = (4 * height) AND 255
 GOSUB callinterrupt
 regah = 0: regal = &HF   'set speed
 regch = 0: regcl = 8 \ 4 'x
 regdh = 0: regdl = 8 \ 4 'y
 GOTO callinterrupt

mousestatus:
 interrupt = 51
 regah = 0: regal = 3
 GOSUB callinterrupt
 mousex = (regcl + 256 * regch) \ 4
 mousey = (regdl + 256 * regdh) \ 4
 mousebuttons = regbl
RETURN

readasmcode:
  RESTORE readasmcode
  DEF SEG = VARSEG(asm%(0))
 
  READ asm$: codelen = LEN(asm$) \ 2
  FOR i = 0 TO codelen - 1
   d = VAL("&h" + MID$(asm$, 1 + 2 * i, 2))
   POKE i, d   'im varseg von a%(0) ist varptr(a%(0))=0
  NEXT i
  DATA  060e07bf4000b8004fbb0000b90000ba0000cd10071e0e1fa33000891e3200890e3400891636001fcb
  'offs 000102030405060708090a0b0c0d0e0f101112131415161718191a1b1c1d1e1f202122232425262728
  'push es :mov es,cs :mov di,40h :mov ax,4f00h :mov bx,0 :mov cx,0
  'mov dx,0: int 10h :pop es :push ds: mov ds, cs :mov [30h],ax: mov [32h],bx
  'mov [34h],cx :mov [36h],dx : pop ds: retf
 RETURN
'========================================
'FFT stuff:

fftmc:
 DEF SEG = VARSEG(mc%(0))
 CALL absolute(0)
RETURN

'FFT relations between Real/Imaginary gerade/ungerade (even/odd) parts:
'Rg <-> Rg
'Ru <-> Iu
'Ig <-> Ig
'Iu <-> -Ru

calcw: 'nm/2 warp factors
  sc! = 1
  pi! = 4 * ATN(1)
  FOR n = 0 TO nm \ 2 - 1
   w!(2 * n) = sc! * COS(2 * pi! * n / nm)
   w!(2 * n + 1) = sc! * SIN(2 * pi! * n / nm)
  NEXT n
 RETURN

calcbitrev:  'bit reversal table
  FOR n = 0 TO nm - 1
   n2 = 0: n1 = n
   FOR l = 0 TO lm - 1
    n2 = 2 * n2 + (n1 AND 1)
    n1 = n1 \ 2
   NEXT l
   nbr%(n) = n2
  NEXT n
 RETURN

getmc: 'FFT assembler code
  RESTORE float4a
  DEF SEG = VARSEG(mc%(0))
  n0 = 0
  READ i$
  WHILE i$ <> "end"
   FOR n = 0 TO LEN(i$) \ 2 - 1
    POKE n0 + n, VAL("&h" + MID$(i$, 2 * n + 1, 2))
   NEXT n
   n0 = n0 + LEN(i$) \ 2
   READ i$
  WEND
  DEF SEG
  mc%(2) = VARSEG(a!(0))
  mc%(3) = VARSEG(w!(0))
  mc%(4) = VARSEG(nbr%(0))
  mc%(5) = lm
  mc%(6) = nm
 RETURN

float4a:
'assembler FFT
'by Markus Vester, 1999
DATA E9150090000000000000030008000800
DATA 0100000000000000061E2E8E1E04002E
DATA 8E0608002E8B0E0C00BF0000D1E7268B
DATA 35D1EF3BFE7E35C1E603C1E703FF34FF
DATA 358F048F05FF7402FF75028F44028F45
DATA 02FF7404FF75048F44048F4504FF7406
DATA FF75068F44068F4506C1EF0347E2BD2E
DATA 8E0606009BDBE32EC706100001002EA1
DATA 0C00D1E8C1E0032EA30E002EA10A002E
DATA A316002EC706120000002E8B0E10002E
DATA 8B3E12002E8B36120001CEC1E703C1E6
DATA 03BB000026D90726D94704D904D94404
DATA D9C1D8CCD9C1D8CCDEE9D9CAD8CBD9C9
DATA D8CCDEC1D905D94504D9C0D8E3D95C04
DATA D9C1D8E4D91CD8C2D95D04D8C2D91DDD
DATA C3DDC2DDC1DDC083C60883C7082E031E
DATA 0E00E2B02EA112002E030610002E0306
DATA 10002EA312002E3B060C007403E97AFF
DATA 2ED12610002ED12E0E002EFF0E160074
DATA 03E95FFF1F07CB90
DATA end

calcwindow: 'cos^2 FFT window (half length)
 winmax! = 2! / nm / 128!
 IF server THEN winmax! = winmax! / 256!
 FOR n = 0 TO nm \ 2 \ winf - 1
  win1! = COS(pi! * (n / nm * winf - .5))
  win!(n) = (win1! * win1!) * winmax!
 NEXT n
RETURN

'=======================================
fastdb: '(not used)
 msw% = CVI(MID$(MKS$(s!), 3, 2))
 expo% = (msw% AND &H7F80) \ 128 - 127: mant7% = msw% AND 127
 dB! = dB2! * (expo% + dbtab!(mant7%))
RETURN

calcdbtab:
 'fastdb is slightly faster than log with QBasic1.1,
 'but much slower with QB4.5 and coprocessor
 'ieee format: 1bit sign, 8bit exponent, 23bit mantissa without leading 1
 'ieee 1.0:     0          127             0   = 3F 80 00 00
 'MKS$(1.0) (reversed bytes) : 00 00 80 3F

  log2! = LOG(2)
  dB2! = 20 * LOG(2) / LOG(10) '6.0206 dB for Voltage
  dB2! = 10 * LOG(2) / LOG(10) '3.0103 dB for Power
  'using 7bits of mantissa gives about +-.034dB accuracy
  FOR mant7% = 0 TO 127
   s! = 1! + (mant7% + .5) / 128!
   dbtab!(mant7%) = LOG(s!) / log2!
  NEXT mant7%
RETURN
'=================
prepfticks:
 oldfrn& = INT(((npix1 + .5) / nm / mdec * sfreq! + f0# + fbase!) / tickf!)
 FOR n = 0 TO npix - 1
  frn& = INT(((n + .5 + npix1) / nm * sfreq! / mdec + f0# + fbase!) / tickf!)
  IF frn& <> oldfrn& THEN oldfrn& = frn&: fticks%(n) = fticks%(n) + 1
 NEXT n
RETURN

'=======================
'txstuff:
'from morse1jM.bas (df6nm, 9.9.01)

prepsound:
 xtal! = 1193000 'nominal  133 * 8169.92
 xtal! = 1193215 'Notebook 133 * 8971.54
' xtal! = 1193341 '486er    133 * 8972.49
 OUT &H61, INP(&H61) AND 254 'output off
 OUT &H61, INP(&H61) OR 1  'divider on
settxfreq:
 IF txfreq! < 19 THEN txfreq! = 19
 per0& = xtal! / txfreq!
 txfreqp! = xtal! / per0&
 OUT &H43, &HB6
 OUT &H42, per0& AND 255
 OUT &H42, per0& \ 256
 oldper& = per0&
RETURN

getmorse:
 m$ = " ..-.-.- --....- ,--..--"
 m$ = m$ + " a.- b-... c-.-. d-.. e. f..-. g--. h.... i.. j.--- k-.-"
 m$ = m$ + " l.-.. m-- n-. o--- p.--. q--.- r.-. s... t- u..- v...-"
 m$ = m$ + " w.-- x-..- y-.-- z--.. .-.- ---. ..--"
 m$ = m$ + " 0----- 1.---- 2..--- 3...-- 4....- 5..... 6-.... 7--..."
 m$ = m$ + " 8---.. 9----. 0----- /-..-. ?..--.. =-...-  :---..."
 m$ = m$ + " +.-.-. #...-.-"
RETURN

prepcom:
 i% = INP(cp& + 6): i% = INP(cp& + 6)
 i% = INP(cp& + 6)
 OUT cp& + 4, 0
 IF i% = 255 THEN cp& = 0: PRINT "tx com port not available, tone only"

' read modem status twice to notify windows from dos box !
' Windows ME needs 2 times read status
' 3rd read status is different from 255
' and bit 4 (selftest) in modem control has to be reset!

' com port:  rts=key, dtr=ptt, gnd
' DSUB9 Pin:    7        4      5
' DSUB25 Pin:   4       20      7

' DFCW freq output on ptt line (dtr)
' dtrdit% = 1 'dtr lo during dots
' dtrdah% = 0 'dtr lo during dashes
RETURN

rtshi:
 IF cp& THEN OUT cp& + 4, INP(cp& + 4) OR 2
RETURN

rtslo:
 IF cp& THEN OUT cp& + 4, INP(cp& + 4) AND 253
RETURN

dtrhi:
 IF cp& THEN OUT cp& + 4, INP(cp& + 4) OR 1
RETURN

dtrlo:
 IF cp& THEN OUT cp& + 4, INP(cp& + 4) AND 254
RETURN

'=========================================
calcnull:
 nulldir2! = nulldir! + 90!
 cosnull! = nullamplH! * COS(nulldir2! * pi! / 180!)
 sinnull! = nullamplH! * SIN(nulldir2! * pi! / 180!) * rot!
RETURN

'====================
readrxcal: 'for testing
 DIM para!(4)
 CLS
 OPEN "..\fft\rxcal486.txt" FOR INPUT AS 1
 WHILE NOT EOF(1)
  GOSUB readrxcalibline
  IF nparam >= 4 THEN 'at least f, dBE, phE, dBH; optional phH
   FOR npara = 0 TO 4: PRINT para!(npara); " "; : NEXT npara
   PRINT "found"; nparam; "parameters"
  END IF
 WEND
 CLOSE 1
END

rxcalfilenotfound:
 rxcorflag = 0: PRINT "RX calibration data file not found"
 RESUME NEXT

calibrate:
 IF rxcorflag THEN
  DIM para!(4), ptab1!(4), ptab!(4), ptab2!(4)
  ON ERROR GOTO rxcalfilenotfound
  OPEN rxcalfile$ FOR INPUT AS 1
  ON ERROR GOTO 0
  dBcormin! = -20
  ptab2!(0) = -1E+18 'extend first value down to zero
 END IF

 FOR nf = npix1 TO npix2
  nfxx = nf - npix1
  frnf! = sfreq! * nf / nm
  IF decimateflag THEN frnf! = sfreq! * nf / nm / mdec + f0#
 
  'dnf! = 4! * frnf! / sfreq!   'slope varies for pre-decimated samplerate
  'dnf! = 4! * frnf! / 5541.4  'fixed normalization: degrees / 1.385 kHz
  dnf! = frnf! / 1000!   'now degrees / kHz
  ph! = (phoffs! + dnf! * (phgrad! + dnf! * phquad!)) * pi! / 180!
  amE! = 1!
  amH! = 1! * ahe!
 
  IF rxcorflag THEN
   WHILE ptab2!(0) <= frnf!
    FOR np = 0 TO 4: ptab1!(np) = ptab2!(np): NEXT np
    GOSUB readrxcalibline
    IF nparam >= 4 THEN
     FOR np = 0 TO 4: ptab2!(np) = para!(np): NEXT np
    ELSE
     ptab2!(0) = frnf! + 1E+18 'no more lines in file ... keep values
    END IF
   WEND
   FOR np = 1 TO 4  'interpolate dB_E, ph_E,dB_H,ph_H
    ptab!(np) = ptab1!(np) + (ptab2!(np) - ptab1!(np)) * (frnf! - ptab1!(0)) / (ptab2!(0) - ptab1!(0))
   NEXT np
   IF RXcaldBflag THEN
    dBcorE! = ptab!(1) * dBdatasign! - dBdataoffs!
   ELSE
    IF ptab!(1) > 0! THEN
     dBcorE! = 20! * (LOG(ptab!(1)) / LOG(10)) * dBdatasign! - dBdataoffs!
    ELSE
     dBcorE! = dBcormin!
    END IF
   END IF
   IF dBcorE! < dBcormin! THEN dBcorE! = dBcormin!
   amE! = amE! * EXP(-dBcorE! / dBe! / 2!)
   IF RXcaldBflag THEN
    dBcorH! = ptab!(3) * dBdatasign! - dBdataoffs!
   ELSE
    IF ptab!(3) > 0! THEN
     dBcorH! = 20! * (LOG(ptab!(3)) / LOG(10)) * dBdatasign! - dBdataoffs!
    ELSE
     dBcorH! = dBcormin!
    END IF
   END IF
   IF dBcorH! < dBcormin! THEN dBcorH! = dBcormin!
   amH! = amH! * EXP(-dBcorH! / dBe! / 2!)
   ph! = ph! + (ptab!(2) - ptab!(4) - phdataoffs!) * phdatasign! * pi! / 180!
  END IF
 
  IF antcorflag THEN
   IF antFH! <> 0! THEN
    dnf! = (ABS(frnf! + fbase!) - ABS(antFH!)) * 2! * antQH! / antFH!
    ph! = ph! - ATN(dnf!)                'negative Q reverses phase
    IF antFH! >= 0! THEN
     amH! = amH! * SQR(1! + dnf! * dnf!) 'compensate pole (1/maximum)
    ELSE
     amH! = amH! / SQR(1! + dnf! * dnf!) 'use <0 to compensate null (1/minimum)
    END IF
   END IF
   IF antFE! <> 0! THEN
    dnf! = (ABS(frnf! + fbase!) - ABS(antFE!)) * 2! * antQE! / antFE!
    ph! = ph! + ATN(dnf!)
    IF antFE! >= 0! THEN
     amE! = amE! * SQR(1! + dnf! * dnf!)
    ELSE
     amE! = amE! / SQR(1! + dnf! * dnf!)
    END IF
   END IF
  END IF
 
  IF decimateflag THEN
   am! = SQR(1! + ((nf - nm / 4!) * pi2! / (mdec * decf2! * nm)) ^ 2!)
   am! = am! ^ (deciorder2 \ 2)
   amE! = amE! * am!: amH! = amH! * am!
  END IF
 
  fram1!(nfxx) = SQR(.5) * amE!
  frre!(nfxx) = SQR(.5) * amH! * COS(ph!)
  frim!(nfxx) = SQR(.5) * amH! * SIN(ph!)
 
  'PRINT frnf!; amE!; amH!; ph!

 NEXT nf
 IF rxcorflag THEN CLOSE 1
RETURN

readrxcalibline:
 ' format:
 ' f/Hz |E|/dB ph(E)/deg |H|/dB [ph(H)/deg]
 ' numbers separated by spaces, semicolon introduces comment
 ' (dB should be negative where RX is insensitive)
 ' to calibrate, connect both RX inputs to a source and read dB|E|, phi(E) and dB|H| from cursor

 nparam = 0
 WHILE nparam < 4 AND NOT EOF(1)
  LINE INPUT #1, line$
  'PRINT line$
  nparam = 0
  FOR np = 0 TO 4
   para!(np) = 0
   line$ = LTRIM$(line$)
   IF line$ <> "" THEN
    IF LEFT$(line$, 1) = ";" THEN GOTO lineend
    nextblank = INSTR(line$, " ")
    IF nextblank = 0 THEN nextblank = LEN(line$) + 1
    'PRINT "*"; line$; "*"; LEFT$(line$, nextblank - 1); "*"
    para!(np) = VAL(LEFT$(line$, nextblank - 1))
    line$ = MID$(line$, nextblank, LEN(line$) - nextblank + 1)
    nparam = np + 1
lineend:
   END IF
  NEXT np
 WEND
RETURN

