;float4a
; by Markus Vester, DF6NM
; complete fft for basic

 org 0
 jmp main

;*********
even 2

aseg dw 0      ;fft data (r4i4r4i4..)
wseg dw 0      ;warp factors (r4i4r4i4..)
brtabseg dw 0  ;bit reversal table  (words)

lm dw 3        ;stages (=ld fft length)
nm dw 8        ;fft length

nwd8 dw 8
nd dw 1
n0 dw 0
n1 dw 0
l dw 0

;*********
main:

 push es
 push ds
 cs mov ds,aseg

;bit reversal:
 cs mov es,brtabseg
 cs mov cx,nm
 mov di,0

brloop:
  shl di,1
  mov si,[es:di]
  shr di,1
  cmp di,si  ;noswap if di-si <= 0
  jle noswap
   shl si,3  ;swap if si<di
   shl di,3
   xchg [ds:si],[ds:di]
   xchg [ds:si+2],[ds:di+2]
   xchg [ds:si+4],[ds:di+4]
   xchg [ds:si+6],[ds:di+6]
   shr di,3
noswap:
  inc di
 loop brloop

;fft:
 cs mov es,wseg

 finit

 cs mov w nd,1    ;nd=1
 cs mov ax,w nm
 shr ax,1
 shl ax,3
 cs mov nwd8,ax  ;nwd=nm/2
 cs mov ax,w lm
 cs mov w l,ax    

for_l:           ;for l = lm to 1 step -1
  cs mov w n0,0

for_n0:          ;for n0 = 0 to nm-1 step 2*nd
   cs mov cx,w nd
   cs mov di,w n0
   cs mov si,w n0
   add si,cx       ;n2 = n1 + nd
   shl di,3
   shl si,3
   mov bx,0        ;nw = 0

for_n1:          ;for n1 = n0 to nm0 + nd

;butterfly:
                ; 0  1  2  3  4  5  6  7
 es fld d[bx]   ;wr
 es fld d[bx+4] ;wi wr

 fld d[si]      ;ar wi wr         ;ar(n2)
 fld d[si+4]    ;ai ar wi wr      ;ai(n2)
 fld 1          ;ar ai ar wi wr
 fmul 4         ;rr ai ar wi wr
 fld 1          ;ai rr ai ar wi wr
 fmul 4         ;ii rr ai ar wi wr
 fsub           ;vr ai ar wi wr
 fxch 2         ;ar ai vr wi wr
 fmul 3         ;ri ai vr wi wr
 fxch 1         ;ai ri vr wi wr
 fmul 4         ;ir ri vr wi wr


 fadd           ;vi vr wi wr

                ; 0  1  2  3  4  5  6  7

 fld d[di]      ;1r vi vr wi wr         ;ar(n1)
 fld d[di+4]    ;1i 1r vi vr wi wr      ;ai(n1)

 fld 0          ;1i 1i 1r vi vr wi wr 
 fsub 3         ;2I 1i 1r vi vr wi wr 
 fstp d[si+4]   ;1i 1r vi vr wi wr      ;ai(n2)=ai(n1)-vi
 fld 1          ;1r 1i 1r vi vr wi wr 
 fsub 4         ;2R 1i 1r vi vr wi wr 
 fstp d[si]     ;1i 1r vi vr wi wr      ;ar(n2)=ar(n1)-vr

 fadd 2         ;1I 1r vi vr wi wr
 fstp d[di+4]   ;1r vi vr wi wr         ;ai(n1)=ai(n1)+vi
 fadd 2         ;1R vi vr wi wr
 fstp d[di]     ;vi vr wi wr            ;ar(n1)=ar(n1)+vr

 ffree 3
 ffree 2
 ffree 1
 ffree 0

    add si,8
    add di,8
    cs add bx,w nwd8     ;nw=nw + nwd
   loop for_n1          ;counts down cx

   cs mov ax,n0
   cs add ax,nd
   cs add ax,nd
   cs mov n0,ax       ;...step 2*nd
   cs cmp ax,nm
   je next_n0
   jmp for_n0

next_n0:

  cs shl nd,1      ;nd = 2 * nd
  cs shr nwd8,1    ;ndw = nwd / 2

  cs dec l
  je fft_done
  jmp for_l
fft_done:

 pop ds
 pop es
 retf

 even 2
